JUCE: CodeDocument Class Reference

JUCE

Classes | Public Member Functions | List of all members
CodeDocument Class Reference
juce_gui_extra » code_editor

A class for storing and manipulating a source code file. More...

`#include <juce_CodeDocument.h>`

## Classes
class | Iterator
| Iterates the text in a CodeDocument. More...
class | Listener
| An object that receives callbacks from the CodeDocument when its text changes. More...
class | Position
| A position in a code document. More...

## Public Member Functions
| CodeDocument ()
| Creates a new, empty document. More...
| ~CodeDocument ()
| Destructor. More...
String | getAllContent () const
| Returns the full text of the document. More...
String | getTextBetween (const Position &start, const Position &end) const
| Returns a section of the document's text. More...
String | getLine (int lineIndex) const noexcept
| Returns a line from the document. More...
int | getNumCharacters () const noexcept
| Returns the number of characters in the document. More...
int | getNumLines () const noexcept
| Returns the number of lines in the document. More...
int | getMaximumLineLength () noexcept
| Returns the number of characters in the longest line of the document. More...
void | deleteSection (const Position &startPosition, const Position &endPosition)
| Deletes a section of the text. More...
void | deleteSection (int startIndex, int endIndex)
| Deletes a section of the text. More...
void | insertText (const Position &position, const String &text)
| Inserts some text into the document at a given position. More...
void | insertText (int insertIndex, const String &text)
| Inserts some text into the document at a given position. More...
void | replaceSection (int startIndex, int endIndex, const String &newText)
| Replaces a section of the text with a new string. More...
void | replaceAllContent (const String &newContent)
| Clears the document and replaces it with some new text. More...
void | applyChanges (const String &newContent)
| Analyses the changes between the current content and some new text, and applies those changes. More...
bool | loadFromStream (InputStream &stream)
| Replaces the editor's contents with the contents of a stream. More...
bool | writeToStream (OutputStream &stream)
| Writes the editor's current contents to a stream. More...
String | getNewLineCharacters () const noexcept
| Returns the preferred new-line characters for the document. More...
void | setNewLineCharacters (const String &newLineCharacters) noexcept
| Sets the new-line characters that the document should use. More...
void | newTransaction ()
| Begins a new undo transaction. More...
void | undo ()
| Undo the last operation. More...
void | redo ()
| Redo the last operation. More...
void | clearUndoHistory ()
| Clears the undo history. More...
UndoManager & | getUndoManager () noexcept
| Returns the document's UndoManager. More...
void | setSavePoint () noexcept
| Makes a note that the document's current state matches the one that is saved. More...
bool | hasChangedSinceSavePoint () const noexcept
| Returns true if the state of the document differs from the state it was in when setSavePoint() was last called. More...
Position | findWordBreakAfter (const Position &position) const noexcept
| Searches for a word-break. More...
Position | findWordBreakBefore (const Position &position) const noexcept
| Searches for a word-break. More...
void | findTokenContaining (const Position &pos, Position &start, Position &end) const noexcept
| Finds the token that contains the given position. More...
void | findLineContaining (const Position &pos, Position &start, Position &end) const noexcept
| Finds the line that contains the given position. More...
void | addListener (Listener *listener)
| Registers a listener object to receive callbacks when the document changes. More...
void | removeListener (Listener *listener)
| Deregisters a listener. More...

## Detailed Description

A class for storing and manipulating a source code file.

When using a CodeEditorComponent, it takes one of these as its source object.

The CodeDocument stores its content as an array of lines, which makes it quick to insert and delete.

See also
  CodeEditorComponent

## Constructor & Destructor Documentation

## ◆ CodeDocument()

CodeDocument::CodeDocument | ( |  | ) |

Creates a new, empty document.

## ◆ ~CodeDocument()

CodeDocument::~CodeDocument | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ getAllContent()

String CodeDocument::getAllContent | ( |  | ) | const

Returns the full text of the document.

## ◆ getTextBetween()

String CodeDocument::getTextBetween | ( | const Position & | start,
|  | const Position & | end
| ) |  | const

Returns a section of the document's text.

## ◆ getLine()

String CodeDocument::getLine | ( | int | lineIndex | ) | const
| noexcept

Returns a line from the document.

## ◆ getNumCharacters()

int CodeDocument::getNumCharacters | ( |  | ) | const
| noexcept

Returns the number of characters in the document.

## ◆ getNumLines()

int CodeDocument::getNumLines | ( |  | ) | const
| noexcept

Returns the number of lines in the document.

## ◆ getMaximumLineLength()

int CodeDocument::getMaximumLineLength | ( |  | ) |
| noexcept

Returns the number of characters in the longest line of the document.

## ◆ deleteSection() [1/2]

void CodeDocument::deleteSection | ( | const Position & | startPosition,
|  | const Position & | endPosition
| ) |  |

Deletes a section of the text.

This operation is undoable.

## ◆ deleteSection() [2/2]

void CodeDocument::deleteSection | ( | int | startIndex,
|  | int | endIndex
| ) |  |

Deletes a section of the text.

This operation is undoable.

## ◆ insertText() [1/2]

void CodeDocument::insertText | ( | const Position & | position,
|  | const String & | text
| ) |  |

Inserts some text into the document at a given position.

This operation is undoable.

## ◆ insertText() [2/2]

void CodeDocument::insertText | ( | int | insertIndex,
|  | const String & | text
| ) |  |

Inserts some text into the document at a given position.

This operation is undoable.

## ◆ replaceSection()

void CodeDocument::replaceSection | ( | int | startIndex,
|  | int | endIndex,
|  | const String & | newText
| ) |  |

Replaces a section of the text with a new string.

This operation is undoable.

## ◆ replaceAllContent()

void CodeDocument::replaceAllContent | ( | const String & | newContent | ) |

Clears the document and replaces it with some new text.

This operation is undoable - if you're trying to completely reset the document, you might want to also call clearUndoHistory() and setSavePoint() after using this method.

## ◆ applyChanges()

void CodeDocument::applyChanges | ( | const String & | newContent | ) |

Analyses the changes between the current content and some new text, and applies those changes.

## ◆ loadFromStream()

bool CodeDocument::loadFromStream | ( | InputStream & | stream | ) |

Replaces the editor's contents with the contents of a stream.

This will also reset the undo history and save point marker.

## ◆ writeToStream()

bool CodeDocument::writeToStream | ( | OutputStream & | stream | ) |

Writes the editor's current contents to a stream.

## ◆ getNewLineCharacters()

String CodeDocument::getNewLineCharacters | ( |  | ) | const
| noexcept

Returns the preferred new-line characters for the document.

This will be either "\\n", "\\r\\n", or (rarely) "\\r".

See also
  setNewLineCharacters

## ◆ setNewLineCharacters()

void CodeDocument::setNewLineCharacters | ( | const String & | newLineCharacters | ) |
| noexcept

Sets the new-line characters that the document should use.

The string must be either "\\n", "\\r\\n", or (rarely) "\\r".

See also
  getNewLineCharacters

## ◆ newTransaction()

void CodeDocument::newTransaction | ( |  | ) |

Begins a new undo transaction.

The document itself will not call this internally, so relies on whatever is using the document to periodically call this to break up the undo sequence into sensible chunks.

See also
  UndoManager::beginNewTransaction

## ◆ undo()

void CodeDocument::undo | ( |  | ) |

Undo the last operation.

See also
  UndoManager::undo

## ◆ redo()

void CodeDocument::redo | ( |  | ) |

Redo the last operation.

See also
  UndoManager::redo

## ◆ clearUndoHistory()

void CodeDocument::clearUndoHistory | ( |  | ) |

Clears the undo history.

See also
  UndoManager::clearUndoHistory

## ◆ getUndoManager()

UndoManager & CodeDocument::getUndoManager | ( |  | ) |
| noexcept

Returns the document's UndoManager.

## ◆ setSavePoint()

void CodeDocument::setSavePoint | ( |  | ) |
| noexcept

Makes a note that the document's current state matches the one that is saved.

After this has been called, hasChangedSinceSavePoint() will return false until the document has been altered, and then it'll start returning true. If the document is altered, but then undone until it gets back to this state, hasChangedSinceSavePoint() will again return false.

See also
  hasChangedSinceSavePoint

## ◆ hasChangedSinceSavePoint()

bool CodeDocument::hasChangedSinceSavePoint | ( |  | ) | const
| noexcept

Returns true if the state of the document differs from the state it was in when setSavePoint() was last called.

See also
  setSavePoint

## ◆ findWordBreakAfter()

Position CodeDocument::findWordBreakAfter | ( | const Position & | position | ) | const
| noexcept

Searches for a word-break.

## ◆ findWordBreakBefore()

Position CodeDocument::findWordBreakBefore | ( | const Position & | position | ) | const
| noexcept

Searches for a word-break.

## ◆ findTokenContaining()

void CodeDocument::findTokenContaining | ( | const Position & | pos,
|  | Position & | start,
|  | Position & | end
| ) |  | const
| noexcept

Finds the token that contains the given position.

## ◆ findLineContaining()

void CodeDocument::findLineContaining | ( | const Position & | pos,
|  | Position & | start,
|  | Position & | end
| ) |  | const
| noexcept

Finds the line that contains the given position.

## ◆ addListener()

void CodeDocument::addListener | ( | Listener * | listener | ) |

Registers a listener object to receive callbacks when the document changes.

If the listener is already registered, this method has no effect.

See also
  removeListener

## ◆ removeListener()

void CodeDocument::removeListener | ( | Listener * | listener | ) |

Deregisters a listener.

See also
  addListener

The documentation for this class was generated from the following file:

- juce_CodeDocument.h